//upload.xul, download.xul, and browser.xul(Overlay)

const NS_ERROR_MODULE_NETWORK = 2152398848; //z.B. in http://lxr.mozilla.org/mozilla/source/browser/base/content/web-panels.js
const NS_BINDING_ABORTED = NS_ERROR_MODULE_NETWORK + 2; // z.B. in http://lxr.mozilla.org/mozilla/source/netwerk/base/public/nsNetError.h

var gBookmarksSynchronizerUploadService=
{
  _channel:null,
  _callback:null,
  _data:"",
  _scheme:"",
  _errorData:"",

  start:function(aStr,aURI,aType,aCallback)
  {
    if( !aStr || !aURI)
      return -1;
    this._callback=aCallback;
    this._scheme=aURI.scheme;
    const ioService  = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);
    const stringStream=Components.classes["@mozilla.org/io/string-input-stream;1"]
                      .createInstance(Components.interfaces.nsIStringInputStream);
    try{
      this._channel = ioService.newChannelFromURI( aURI )
                        .QueryInterface(Components.interfaces.nsIUploadChannel);
      stringStream.setData(aStr, -1);
      this._channel.setUploadStream(stringStream,aType,-1);
      this._channel.asyncOpen(this, null);
      this._callback("send",status);
      this._data=aStr;
    } catch(e) {
      dump('ABS-Upload:\n'+e+'\n');
      return e.result;
    }
    return 0;
  },

  cancel:function()
  {
    if(this._channel)
      this._channel.cancel(0x804b0002);
  },

  onDataAvailable: function (channel, ctxt, input, sourceOffset, count){
    const sis=Components.classes["@mozilla.org/scriptableinputstream;1"]
                      .createInstance(Components.interfaces.nsIScriptableInputStream);
    sis.init(input);
    this._errorData +=sis.read(count);
  },
  onStartRequest: function (channel, ctxt){},
  onStopRequest: function (channel, ctxt, status)
  {
    if(this._scheme != "ftp"){
      var res=0;
      try{
        res = channel.QueryInterface(Components.interfaces.nsIHttpChannel)
                       .responseStatus;
      }catch(e){}
      if(res==200||res==201 || res==204)
        status=0;
      /*
        200:OK
        201:Created
        204:No Content
        This is an uploading channel, no need to "GET" the file contents.
      */
      if(this._errorData)
        status=res;
      if(this._errorData && res==200)
        alert(this._errorData);
    }
    if(this._callback)
      this._callback("done",status);
  }
};

var gBookmarksSynchronizerDownloadService=
{
  _channel:null,
  data:null,
  length:null,
  remoteLastModTime:null,

  _lastModifiedTime:null,
  _callback:null,
  _cur:null,


  start:function(aURI,aCallback,usePost, flmt, cur)
  {
    if( !aURI )
      return -1;

    this._callback=aCallback;
    this._lastModifiedTime=flmt;
    this._cur=cur;

    try{
      var ioService  = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);
      this.streamLoader=Components.classes["@mozilla.org/network/stream-loader;1"]
                    .createInstance(Components.interfaces.nsIStreamLoader);
      this._channel = ioService.newChannelFromURI( aURI );  //nsIChannel
      if(aURI.scheme=="http" || aURI.scheme=="https") {
        this._channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
        if (usePost) {
          this._channel.QueryInterface(Components.interfaces.nsIHttpChannel).requestMethod='POST';
        }
//this._channel.QueryInterface(Components.interfaces.nsIHttpChannel).requestMethod='HEAD';
      }
      this._channel.asyncOpen(this , null);
    } catch(e) {
      dump('ABS-Download:\n'+e+'\n');
      return e.result;
    }
    return 0;
  },

  cancel:function()
  {
    if(this._channel)
      this._channel.cancel(0x804b0002);
  },


  onDataAvailable: function(request, context, inputStream, offset, count){
//dump('data available at offset='+offset+' '+count+' bytes\n');
    try {
      var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].
          createInstance(Components.interfaces.nsIScriptableInputStream);
      sis.init(inputStream);
      this.data+=sis.read(count);
      if (this.length==0 && this._lastModifiedTime) { // on first data, check time
        //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
        if (this.data.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
            //extract lastModifiedDate from mork line
          var matches=this.data.match(/-->([^\r\n]*)/);
          var rlmt=new Date(matches[1]);  //invalid date, if no match => rlmt<=this._lastModifiedTime is false!
          this.remoteLastModTime=rlmt;
          if (rlmt<=this._lastModifiedTime) {
            //Components.results.NS_BINDING_ABORTED ist leider undefined, daher oben definiert
            request.cancel(NS_BINDING_ABORTED);
//dump('Time check: aborted with code '+NS_BINDING_ABORTED+'\n');
          } else if (!askOverwrite(this._cur, false)) {
            this.remoteLastModTime=null;
            request.cancel(NS_BINDING_ABORTED);
          }
        }
      }
      this.length+=count;

    } catch(e) { if (e.result!=NS_BINDING_ABORTED) alert(e+'\noffset='+offset+' count='+count); }
  },
  onStartRequest: function(request, context) {
//dump('start request\n');
    this.length=0;
    this.data='';
  },
  onStopRequest: function(request, context, statusCode) {
//dump('stop request-'+request.status+'-'+statusCode+' \n');
    if (statusCode) {
//alert('Error '+statusCode+'--'+this.data.substr(0,1000));
    }
    if (this._callback)
      this._callback("done",statusCode);

  }
};
